org.apache.lucene.search

## Class FuzzyTermsEnum

- java.lang.Object
- - org.apache.lucene.index.TermsEnum
  - - org.apache.lucene.search.FuzzyTermsEnum

- All Implemented Interfaces:
    BytesRefIterator

      public final class FuzzyTermsEnum
      extends TermsEnum

  Subclass of TermsEnum for enumerating all terms that are similar to the specified filter term.

  Term enumerations are always ordered by `BytesRef.compareTo(org.apache.lucene.util.BytesRef)`. Each term in the enumeration is greater than all that precede it.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static interface` | `FuzzyTermsEnum.LevenshteinAutomataAttribute` reuses compiled automata across different segments, because they are independent of the index
    `static class` | `FuzzyTermsEnum.LevenshteinAutomataAttributeImpl` Stores compiled automata as a list (indexed by edit distance)

    - ### Nested classes/interfaces inherited from class org.apache.lucene.index.TermsEnum

      `TermsEnum.SeekStatus`

  - ### Field Summary

    - ### Fields inherited from class org.apache.lucene.index.TermsEnum

      `EMPTY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FuzzyTermsEnum(Terms terms, AttributeSource atts, Term term, int maxEdits, int prefixLength, boolean transpositions)` Constructor for enumeration of all terms from specified `reader` which share a prefix of length `prefixLength` with `term` and which have at most `maxEdits` edits.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `docFreq()` Returns the number of documents containing the current term.
    `BytesRef` | `next()` Increments the iteration to the next `BytesRef` in the iterator.
    `long` | `ord()` Returns ordinal position for current term.
    `PostingsEnum` | `postings(PostingsEnum reuse, int flags)` Get `PostingsEnum` for the current term, with control over whether freqs, positions, offsets or payloads are required.
    `TermsEnum.SeekStatus` | `seekCeil(BytesRef text)` Seeks to the specified term, if it exists, or to the next (ceiling) term.
    `boolean` | `seekExact(BytesRef text)` Attempts to seek to the exact term, returning true if the term is found.
    `void` | `seekExact(BytesRef term, TermState state)` Expert: Seeks a specific position by `TermState` previously obtained from `TermsEnum.termState()`.
    `void` | `seekExact(long ord)` Seeks to the specified term by ordinal (position) as previously returned by `TermsEnum.ord()`.
    `BytesRef` | `term()` Returns current term.
    `TermState` | `termState()` Expert: Returns the TermsEnums internal state to position the TermsEnum without re-seeking the term dictionary.
    `long` | `totalTermFreq()` Returns the total number of occurrences of this term across all documents (the sum of the freq() for each doc that has this term).

    - ### Methods inherited from class org.apache.lucene.index.TermsEnum

      `attributes, postings`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### FuzzyTermsEnum

          public FuzzyTermsEnum(Terms terms,
                                AttributeSource atts,
                                Term term,
                                int maxEdits,
                                int prefixLength,
                                boolean transpositions)
                         throws IOException

      Constructor for enumeration of all terms from specified `reader` which share a prefix of length `prefixLength` with `term` and which have at most `maxEdits` edits.

      After calling the constructor the enumeration is already pointing to the first valid term if such a term exists.

      Parameters:
        `terms` - Delivers terms.
        `atts` - `AttributeSource` created by the rewrite method of `MultiTermQuery` thats contains information about competitive boosts during rewrite. It is also used to cache DFAs between segment transitions.
        `term` - Pattern term.
        `maxEdits` - Maximum edit distance.
        `prefixLength` - Length of required common prefix. Default value is 0.
      Throws:
        `IOException` - if there is a low-level IO error

  - ### Method Detail

    - #### next

          public BytesRef next()
                        throws IOException

      Description copied from interface: `BytesRefIterator`
      Increments the iteration to the next `BytesRef` in the iterator. Returns the resulting `BytesRef` or `null` if the end of the iterator is reached. The returned BytesRef may be re-used across calls to next. After this method returns null, do not call it again: the results are undefined.
      Returns:
        the next `BytesRef` in the iterator or `null` if the end of the iterator is reached.
      Throws:
        `IOException` - If there is a low-level I/O error.

    - #### docFreq

          public int docFreq()
                      throws IOException

      Description copied from class: `TermsEnum`
      Returns the number of documents containing the current term. Do not call this when the enum is unpositioned. `TermsEnum.SeekStatus.END`.
      Specified by:
        `docFreq` in class `TermsEnum`
      Throws:
        `IOException`

    - #### totalTermFreq

          public long totalTermFreq()
                             throws IOException

      Description copied from class: `TermsEnum`
      Returns the total number of occurrences of this term across all documents (the sum of the freq() for each doc that has this term). This will be -1 if the codec doesn't support this measure. Note that, like other term measures, this measure does not take deleted documents into account.
      Specified by:
        `totalTermFreq` in class `TermsEnum`
      Throws:
        `IOException`

    - #### postings

          public PostingsEnum postings(PostingsEnum reuse,
                                       int flags)
                                throws IOException

      Description copied from class: `TermsEnum`
      Get `PostingsEnum` for the current term, with control over whether freqs, positions, offsets or payloads are required. Do not call this when the enum is unpositioned. This method will not return null.

      NOTE: the returned iterator may return deleted documents, so deleted documents have to be checked on top of the `PostingsEnum`.

      Specified by:
        `postings` in class `TermsEnum`
      Parameters:
        `reuse` - pass a prior PostingsEnum for possible reuse
        `flags` - specifies which optional per-document values you require; see `PostingsEnum.FREQS`
      Throws:
        `IOException`

    - #### seekExact

          public void seekExact(BytesRef term,
                                TermState state)
                         throws IOException

      Description copied from class: `TermsEnum`
      Expert: Seeks a specific position by `TermState` previously obtained from `TermsEnum.termState()`. Callers should maintain the `TermState` to use this method. Low-level implementations may position the TermsEnum without re-seeking the term dictionary.

      Seeking by `TermState` should only be used iff the state was obtained from the same `TermsEnum` instance.

      NOTE: Using this method with an incompatible `TermState` might leave this `TermsEnum` in undefined state. On a segment level `TermState` instances are compatible only iff the source and the target `TermsEnum` operate on the same field. If operating on segment level, TermState instances must not be used across segments.

      NOTE: A seek by `TermState` might not restore the `AttributeSource`'s state. `AttributeSource` states must be maintained separately if this method is used.

      Overrides:
        `seekExact` in class `TermsEnum`
      Parameters:
        `term` - the term the TermState corresponds to
        `state` - the `TermState`
      Throws:
        `IOException`

    - #### termState

          public TermState termState()
                              throws IOException

      Description copied from class: `TermsEnum`
      Expert: Returns the TermsEnums internal state to position the TermsEnum without re-seeking the term dictionary.

      NOTE: A seek by `TermState` might not capture the `AttributeSource`'s state. Callers must maintain the `AttributeSource` states separately

      Overrides:
        `termState` in class `TermsEnum`
      Throws:
        `IOException`
      See Also:
        `TermState`, `TermsEnum.seekExact(BytesRef, TermState)`

    - #### ord

          public long ord()
                   throws IOException

      Description copied from class: `TermsEnum`
      Returns ordinal position for current term. This is an optional method (the codec may throw `UnsupportedOperationException`). Do not call this when the enum is unpositioned.
      Specified by:
        `ord` in class `TermsEnum`
      Throws:
        `IOException`

    - #### seekExact

          public boolean seekExact(BytesRef text)
                            throws IOException

      Description copied from class: `TermsEnum`
      Attempts to seek to the exact term, returning true if the term is found. If this returns false, the enum is unpositioned. For some codecs, seekExact may be substantially faster than `TermsEnum.seekCeil(org.apache.lucene.util.BytesRef)`.
      Overrides:
        `seekExact` in class `TermsEnum`
      Throws:
        `IOException`

    - #### seekCeil

          public TermsEnum.SeekStatus seekCeil(BytesRef text)
                                        throws IOException

      Description copied from class: `TermsEnum`
      Seeks to the specified term, if it exists, or to the next (ceiling) term. Returns SeekStatus to indicate whether exact term was found, a different term was found, or EOF was hit. The target term may be before or after the current term. If this returns SeekStatus.END, the enum is unpositioned.
      Specified by:
        `seekCeil` in class `TermsEnum`
      Throws:
        `IOException`

    - #### seekExact

          public void seekExact(long ord)
                         throws IOException

      Description copied from class: `TermsEnum`
      Seeks to the specified term by ordinal (position) as previously returned by `TermsEnum.ord()`. The target ord may be before or after the current ord, and must be within bounds.
      Specified by:
        `seekExact` in class `TermsEnum`
      Throws:
        `IOException`

    - #### term

          public BytesRef term()
                        throws IOException

      Description copied from class: `TermsEnum`
      Returns current term. Do not call this when the enum is unpositioned.
      Specified by:
        `term` in class `TermsEnum`
      Throws:
        `IOException`

Copyright © 2000-2019 Apache Software Foundation. All Rights Reserved.